bash 4.4 fix
[distro-setup] / conflink
index 74ced8d47622fa9b000a465eac0138162fa69c5c..c385ca04e8e7c9738edaa7be5b480bb25ddef05d 100755 (executable)
--- a/conflink
+++ b/conflink
@@ -5,21 +5,16 @@ trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
 
 
 sysv() {
-    e "$@"
+    echo "$@"
     "$@"
 }
 
 
 #
-if [[ -e /root/.unison && ! -L /root/.unison ]]; then
-    d=/q/p/c/machine_specific/$host/.unison
-    mkdir -p $d
-    mv -f /root/.unison/* $d
-fi
 
 
 shopt -s nullglob
-shopt -s extglob
+shopt -s extglob # note, already set with bash -l
 
 # if we make a link back to the root, traversing the subdirs stops.
 # This makes it so we can do subdir directories. Must call with absolute
@@ -29,9 +24,9 @@ subdir-link-r() {
     local root="$1"
     local targets=()
     if [[ $2 ]]; then
-        targets=( "$2"/!(.git) )
+        targets=( "$2"/!(.git|..|.) )
     else
-        for f in "$1"/!(.git); do
+        for f in "$1"/!(.git|..|.); do
             [[ -d $f ]] && targets+=("$f") ||:
         done
     fi
@@ -48,24 +43,19 @@ subdir-link-r() {
 }
 
 common-file-setup() {
+    local dir fs_files x
     for dir in "$@"; do
+        fs_files=( $dir/filesystem/* )
+        if [[ -e ${fs_files[0]} && $USER == ian ]]; then
+            # note, symlinks get resolved, not copied.
+            sysv s cp -RL ${fs_files[@]} /
+        fi
         if [[ -e $dir/subdir_files ]]; then
             subdir-link-r $dir/subdir_files
         fi
-        local x=( $dir/!(subdir_files|filesystem) )
-        (( ${#x[@]} >= 1 )) || return 0
+        local x=( $dir/!(subdir_files|filesystem|machine_specific) )
+        (( ${#x[@]} >= 1 )) || continue
         sysv lnf ${x[@]} ~
-        # as of this writing, it doesn't exist in /a/c, but I've used it in the past.
-        if [[ -e $dir/filesystem && $USER == ian ]]; then
-            sysv s cp -R $dir/filesystem/* /
-        fi
-    done
-}
-
-link-dirs() {
-    for dir in "$@"; do
-        common-file-setup $dir
-        common-file-setup $dir/machine_specific/$HOSTNAME
     done
 }
 
@@ -74,19 +64,12 @@ c_dirs=(/a/c{,/machine_specific/$HOSTNAME})
 case $USER in
     ian)
         # p needs to go first so .ssh link is created, then config link inside it
-        common-file-setup $dir ${all_dirs[@]}
+        common-file-setup ${all_dirs[@]}
         sudo -u traci "$BASH_SOURCE"
         ;;
     traci)
         common-file-setup ${c_dirs[@]}
         ;;
-    root)
-        if ! $ROOTCMD getent passwd ian; then
-            common-file-setup ${all_dirs[@]}
-        else
-            echo "$0: error: unexpected user"; exit 1
-        fi
-        ;;
     *)
         echo "$0: error: unexpected user"; exit 1
         ;;